﻿using System;
using System.Diagnostics;
using OpcLabs.EasyOpc;
using OpcLabs.EasyOpc.DataAccess;
using OpcLabs.EasyOpc.OperationModel;

namespace BrowseServersWeb
{
    // ReSharper disable InconsistentNaming
    public partial class _Default : System.Web.UI.Page
    // ReSharper restore InconsistentNaming
    {

        // ReSharper disable InconsistentNaming
        protected void Page_Load(object sender, EventArgs e)
        // ReSharper restore InconsistentNaming
        {
            var client = new EasyDAClient();

            try
            {
                ServerElementCollection serverElements = client.BrowseServers("");
                Debug.Assert(serverElements.Keys != null);

                // ReSharper disable once LoopCanBePartlyConvertedToQuery
                foreach (ServerElement serverElement in serverElements)
                {
                    Debug.Assert(serverElement != null);
                    ListBox1.Items.Add(serverElement.ServerClass);
                }
                ListBox1.Visible = true;

            }
            catch (OpcException ex)
            {
                TextBox1.Text = ex.GetBaseException().Message;
                TextBox1.Visible = true;
            }
        }


    protected override void OnInit(EventArgs e)
    {
        base.OnInit(e);

        Load += Page_Load;
    }
    }
}